/*
 * 商学院签到任务完成记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SchoolSignInTaskRecordController : BaseController
    {
        public SchoolSignInTaskRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商学院签到任务完成记录列表

        /// <summary>
        /// 根据条件查询商学院签到任务完成记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SchoolSignInTaskRecord data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商学院签到任务完成记录列表

        /// <summary>
        /// 商学院签到任务完成记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SchoolSignInTaskRecord data, string UserIdMakerCode, string UserIdRealName, string TaskIdSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //任务
            if (!string.IsNullOrEmpty(TaskIdSelect))
            {
                condition += " and TaskId=" + TaskIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolSignInTaskRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //任务
                dic["TaskId"] = RelationClass.GetSchoolSignInTaskInfo(int.Parse(dic["TaskId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加商学院签到任务完成记录

        /// <summary>
        /// 增加或修改商学院签到任务完成记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商学院签到任务完成记录

        /// <summary>
        /// 增加或修改商学院签到任务完成记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SchoolSignInTaskRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("TaskId", data.TaskId); //任务

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("SchoolSignInTaskRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "SchoolSignInTaskRecord", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商学院签到任务完成记录

        /// <summary>
        /// 增加或修改商学院签到任务完成记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SchoolSignInTaskRecord editData = db.SchoolSignInTaskRecord.FirstOrDefault(m => m.Id == Id) ?? new SchoolSignInTaskRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商学院签到任务完成记录

        /// <summary>
        /// 增加或修改商学院签到任务完成记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SchoolSignInTaskRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("TaskId", data.TaskId); //任务

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTaskRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SchoolSignInTaskRecord", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商学院签到任务完成记录信息

        /// <summary>
        /// 删除商学院签到任务完成记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInTaskRecord", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTaskRecord", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInTaskRecord", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTaskRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInTaskRecord", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("SchoolSignInTaskRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("SchoolSignInTaskRecord", Sort, Id);

            AddSysLog(Id.ToString(), "SchoolSignInTaskRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.SchoolSignInTaskRecord.Add(new SchoolSignInTaskRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "SchoolSignInTaskRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SchoolSignInTaskRecord data, string UserIdMakerCode, string UserIdRealName, string TaskIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //任务
            if (!string.IsNullOrEmpty(TaskIdSelect))
            {
                condition += " and TaskId=" + TaskIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolSignInTaskRecord", Fields, "Id desc", "0", 1, 20000, condition, "UserId,TaskId", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //任务
                dic["TaskId"] = RelationClass.GetSchoolSignInTaskInfo(int.Parse(dic["TaskId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("TaskId", "任务");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SchoolSignInTaskRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
